# Installation

The instructions below will help you to properly install the generated package to the lavalite project.

## Location

Extract the package contents to the folder 

`/packages/survey/formm/`

## Composer

Add the below entries in the `composer.json` file's autoload section and run the command `composer dump-autoload` in terminal.

```json

...
     "autoload": {
         ...

        "classmap": [
            ...
            
            "packages/survey/formm/database/seeds",
            
            ...
        ],
        "psr-4": {
            ...
            
            "Survey\\Formm\\": "packages/survey/formm/src",
            
            ...
        }
    },
...

```

## Config

Add the entries in service provider in `config/app.php`

```php

...
    'providers'       => [
        ...
        
        Survey\Formm\Providers\FormmServiceProvider::class,
        
        ...
    ],

    ...

    'alias'             => [
        ...
        
        'Formm'  => Survey\Formm\Facades\Formm::class,
        
        ...
    ]
...

```

## Migrate

After service provider is set run the commapnd to migrate and seed the database.


    php artisan migrate
    php artisan db:seed --class=Survey\\FormmTableSeeder

## Publishing


**Publishing configuration**

    php artisan vendor:publish --provider="Survey\Formm\Providers\FormmServiceProvider" --tag="config"

**Publishing language**

    php artisan vendor:publish --provider="Survey\Formm\Providers\FormmServiceProvider" --tag="lang"

**Publishing views**

    php artisan vendor:publish --provider="Survey\Formm\Providers\FormmServiceProvider" --tag="view"


## URLs and APIs


### Web Urls

**Admin**

    http://path-to-route-folder/admin/formm/{modulename}

**User**

    http://path-to-route-folder/user/formm/{modulename}

**Public**

    http://path-to-route-folder/formms


### API endpoints

**List**
 
    http://path-to-route-folder/api/user/formm/{modulename}
    METHOD: GET

**Create**

    http://path-to-route-folder/api/user/formm/{modulename}
    METHOD: POST

**Edit**

    http://path-to-route-folder/api/user/formm/{modulename}/{id}
    METHOD: PUT

**Delete**

    http://path-to-route-folder/api/user/formm/{modulename}/{id}
    METHOD: DELETE

**Public List**

    http://path-to-route-folder/api/formm/{modulename}
    METHOD: GET

**Public Single**

    http://path-to-route-folder/api/formm/{modulename}/{slug}
    METHOD: GET